customer = new.tableRef("customer", "PostgreSQL", "postgre.config", "tpch")
orders = new.tableRef("orders", "PostgreSQL", "postgre.config", "tpch")
nation = new.tableRef("nation", "PostgreSQL", "postgre.config", "tpch")
region = new.tableRef("region", "PostgreSQL", "postgre.config", "tpch")
supplier = new.tableRef("supplier", "PostgreSQL", "postgre.config", "tpch")
part = new.tableRef("part", "PostgreSQL", "postgre.config", "tpch")
lineitem = new.tableRef("lineitem", "PostgreSQL", "postgre.config", "tpch")
q =
order(function(x) c(x$o_year), function(x) c(TRUE),
group(function(x) c(x$o_year),
select(function(x){
  y = new.env()
  y$o_year = x$o_year
  y$mkt_share = sum(if (x$nation == "BRAZIL") x$volume else 0) / sum(x$volume)
  y
},
from(select(function(x){
       y = new.env()
       y$o_year = format(x$o_orderdate, "%Y")
       y$volume = x$l_extendedprice * (1 - x$l_discount)
       y$nation = x$n_name
       y
     },
     where(function(x) x$r_name == "AMERICA" && x$p_type == "ECONOMY ANODIZED STEEL"
       && x$o_orderdate >= date("1995-01-01") && x$o_orderdate <= date("1996-12-31"),
     join(from(nation),
     join(from(region),
     join(from(nation),
     join(from(customer),
     join(from(orders),
     join(from(supplier),
     join(from(part),
          from(lineitem),
          function(x, y) x$p_partkey == y$l_partkey),
          function(x, y) x$s_suppkey == y$l_suppkey),
          function(x, y) x$o_orderkey == y$l_orderkey),
          function(x, y) x$c_custkey == y$o_custkey),
          function(x, y) x$n_nationkey == y$c_nationkey),
          function(x, y) x$r_regionkey == y$n_regionkey),
          function(x, y) x$n_nationkey == y$s_nationkey)))))))
print(query.force(q))
